\documentclass[10pt,landscape]{article}
\usepackage{multicol}
\usepackage{calc}
\usepackage{ifthen}
\usepackage[landscape]{geometry}
\usepackage{hyperref}
\usepackage[outputdir=out]{minted}

% This sets page margins to .5 inch if using letter paper, and to 1cm
% if using A4 paper. (This probably isn't strictly necessary.)
% If using another size paper, use default 1cm margins.
\ifthenelse{\lengthtest { \paperwidth = 11in}}
	{ \geometry{top=.5in,left=.5in,right=.5in,bottom=.5in} }
	{\ifthenelse{ \lengthtest{ \paperwidth = 297mm}}
		{\geometry{top=1cm,left=1cm,right=1cm,bottom=1cm} }
		{\geometry{top=1cm,left=1cm,right=1cm,bottom=1cm} }
	}

% Turn off header and footer
\pagestyle{empty}

% Redefine section commands to use less space
\makeatletter
\renewcommand{\section}{\@startsection{section}{1}{0mm}%
                                {-1ex plus -.5ex minus -.2ex}%
                                {0.5ex plus .2ex}%x
                                {\normalfont\large\bfseries}}
\renewcommand{\subsection}{\@startsection{subsection}{2}{0mm}%
                                {-1explus -.5ex minus -.2ex}%
                                {0.5ex plus .2ex}%
                                {\normalfont\normalsize\bfseries}}
\renewcommand{\subsubsection}{\@startsection{subsubsection}{3}{0mm}%
                                {-1ex plus -.5ex minus -.2ex}%
                                {1ex plus .2ex}%
                                {\normalfont\small\bfseries}}
\makeatother

% Define BibTeX command
\def\BibTeX{{\rm B\kern-.05em{\sc i\kern-.025em b}\kern-.08em
    T\kern-.1667em\lower.7ex\hbox{E}\kern-.125emX}}

\setlength{\parindent}{0pt}
\setlength{\parskip}{0pt plus 0.5ex}


% -----------------------------------------------------------------------

\begin{document}

\raggedright
\footnotesize
\begin{multicols}{2}
% multicol parameters
% These lengths are set only within the two main columns
%\setlength{\columnseprule}{0.25pt}
% \setlength{\premulticols}{1pt}
% \setlength{\postmulticols}{1pt}
% \setlength{\multicolsep}{1pt}
% \setlength{\columnsep}{2pt}

\begin{center}
     \Large{\textbf{modelbase cheat sheet}} \\
\end{center}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section*{Construction}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection*{Creating the model}

\begin{minted}{Python}
    from modelbase.ode import Model
    m = Model()
\end{minted}

\subsection*{Adding constants}

\begin{minted}{Python}
    m.add_parameter("name", value)
    m.add_parameters({
        "name1": value1,
        "name2": value2,
        ...
    })
\end{minted}

\subsection*{Adding variables}

\begin{minted}{Python}
    m.add_compound("name")
    m.add_compounds(["name1", "name2", ...])
\end{minted}

\subsection*{Adding algebraic modules}

Function arguments by default are passed in the order compounds, modifiers, parameters. If \texttt{args} is used, this order is overwritten.

\begin{minted}{Python}
    def algebraic_fn(*substrates, *modifiers, *parameters):
        ...

    m.add_algebraic_module(
        "name",
        algebraic_fn,
        compounds,          # input to the module
        derived_compounds,  # produced by the module
        parameters=[],
    )
\end{minted}

\columnbreak

\subsection*{Adding reactions}

Function arguments by default are passed in the order substrates, (products if reversible), modifiers, parameters. If \texttt{args} is used, this order is overwritten.

\begin{minted}{Python}
    def irreversible_fn(*substrates, *modifiers, *parameters):
        ...

    def reversible_fn(*substrates, *products, *modifiers, *parameters):
        ...

    m.add_reaction(
        "name",
        irreversible_fn,
        stoichiometry,
        modifiers=[],
        parameters=[],
        reversible=False,
    )
    m.add_reaction_from_ratelaw(name, ratelaw)
    m.add_reaction_from_args(name, fn, stoichiometry, args)
\end{minted}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section*{Introspection}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{minted}{Python}
    y_full = m.get_full_concentration_dict(y)
    v = m.get_fluxes_df(y)
    rhs = m.get_right_hand_side(y)
    N = m.get_stoichiometric_df()

    m.get_...
\end{minted}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section*{Simulation}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{minted}{Python}
    from modelbase.ode import Simulator

    y0 = {"name": value, ...}
    s = Simulator(m)
    s.initialise(y0)
    t, y = s.simulate(100)
    fig, ax = s.plot()

    t_ss, y_ss = s.simulate_to_steady_state()
    df = s.parameter_scan("parameter", [value1, value2, ...])
\end{minted}

\subsection*{Metabolic Control Analysis}

\begin{minted}{Python}
    from modelbase.ode import mca

    crc = mca.get_concentration_response_coefficients_df(m, parameters, y)
    frc = mca.get_flux_response_coefficients_df(m, parameters, y)

    fig, ax, _ = mca.plot_coefficient_heatmap(crc, title)
\end{minted}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section*{Export}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{minted}{Python}
    m.write_sbml_model("filename")
    m.generate_model_source_code()
    m.to_labelmodel(label_compounds, label_maps)
    m.to_linear_labelmodel(label_compounds, label_maps)
\end{minted}

\end{multicols}
\end{document}